package com.xhkjedu.sapi.controller.appversion;

import com.github.pagehelper.PageHelper;
import com.github.pagehelper.PageInfo;
import com.xhkjedu.annotation.Action;
import com.xhkjedu.sapi.model.appversion.TAppRecord;
import com.xhkjedu.sapi.service.appversion.AppRecordService;
import com.xhkjedu.utils.N_Utils;
import com.xhkjedu.utils.PageUtil;
import com.xhkjedu.vo.PageResult;
import com.xhkjedu.vo.ResultVo;
import com.xhkjedu.sapi.vo.appversion.AppversionVo;
import org.springframework.web.bind.annotation.PostMapping;
import org.springframework.web.bind.annotation.RequestBody;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RestController;

import javax.annotation.Resource;
import java.util.List;

/**
 * @classname AppRecordController 微课
 * @description 
 * @date 2020/7/23 16:40
 **/
@RestController
@RequestMapping("/apprecord")
public class AppRecordController {
    @Resource
    private AppRecordService appRecordService;

    @PostMapping("/add")
    @Action("教师微课端-增加")
    public ResultVo add(@RequestBody TAppRecord apprecord) {
        N_Utils.validation(new Object[]{apprecord.getVersionname(),"版本名称",2,
                apprecord.getVersioncode(),"版本号",2,apprecord.getVersionpath(),"应用文件",2});
        Integer id = appRecordService.save(apprecord);
        return new ResultVo(0, "保存成功",id);
    }

    @PostMapping("/delete")
    @Action("教师微课端-删除")
    public ResultVo delete(@RequestBody TAppRecord apprecord) {
        N_Utils.validation(new Object[]{apprecord.getVersionid(),"版本id",1});
        appRecordService.deleteById(apprecord.getVersionid());
        return new ResultVo(0,"删除成功");
    }

    @PostMapping("/update")
    @Action("教师微课端-修改")
    public ResultVo update(@RequestBody TAppRecord apprecord) {
        N_Utils.validation(new Object[]{apprecord.getVersionid(),"版本id",1});
        appRecordService.update(apprecord);
        return new ResultVo(0,"修改成功");
    }

    @PostMapping("/detail")
    public ResultVo detail(@RequestBody TAppRecord apprecord) {
        N_Utils.validation(new Object[]{apprecord.getVersionid(),"版本id",1});
        TAppRecord record = appRecordService.findById(apprecord.getVersionid());
        return new ResultVo(0,"获取详情成功",record);
    }

    @PostMapping("/list")
    public ResultVo list(@RequestBody TAppRecord apprecord) {
        PageHelper.startPage(apprecord.getPage(), apprecord.getPageSize());
        List<AppversionVo> list = appRecordService.listAll();
        PageResult pageResult = PageUtil.getPageResult(new PageInfo(list));
        return new ResultVo(0,"获取app版本列表成功",pageResult);
    }

    @PostMapping("/get_new")
    public ResultVo getNew() {
        TAppRecord apprecord = appRecordService.getNew();
        return new ResultVo(0,"获取最新app版本成功",apprecord);
    }
}
